<?php
/* RACCOLTA FUNZIONI PER SITO PHP
   By Walter Lain 2006
 --------------------------------------------------------------------

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program (in a file called LICENSE.txt); if not, go
 to http://www.gnu.org/copyleft/gpl.html or write to 
 
   Free Software Foundation, Inc.
     59 Temple Place - Suite 330
       Boston, MA 02111-1307 USA
       
 --------------------------------------------------------------------
*/

/****************************************************
 *                  crea_pcinfo                     *
 ****************************************************
 Crea il report sui PC analizzati 
 nomefile: file da cui prendere i dati
*/

function crea_pcinfo($nomefile)
{
    $file=fopen($nomefile,"r");
    $file_dim=filesize($nomefile);
    $count=0;

    //il primo campo contiene il nome del PC analizzato
    $campo1=fgets($file,$file_dim);//carico una nuova riga dal file
    $temp=explode(": ",$campo1);
    $nome_pc=$temp[1];
    
    //il secondo campo contiene la quantit�di RAM
    $campo1=fgets($file,$file_dim);//carico una nuova riga dal file
    $temp=explode("\t",$campo1);
    $ram_memory=(int)($temp[3]/1024);
    
    //uno o piu' campi contengono le dimensioni degli hard disks
    $n=0;
    do
    {
	$campo1=fgets($file,$file_dim);//carico una nuova riga dal file
	$temp=explode("\t",$campo1);
	if ($temp[1]!="HARDWARE/DiskSize") {break;}
	$disk_size[$n]=$temp[3];
	$n++;
    }    
    while(!feof($file));

    //recupero informazioni sul sistema operativo
    while(!feof($file))
    {
	$temp=explode("\t",$campo1);
	//controllo se sto ancora nessa sezione "CurrentVersion", altrimenti esco
	if($temp[1]!="SOFTWARE/CurrentVersion")
	{
	    break;
	}
	//estraggo i dati che mi servono
	switch($temp[2])
	{
	    case "ProductName":
	    {
		$op_sys=$temp[3];
		break;
	    }
	    case "CurrentBuildNumber": //win 2000 e XP usano questo come versione
	    {
		$os_version=$temp[3];
		break;
	    }
	    case "VersionNumber": //win9x usa questo come versione
	    {
		$os_version=$temp[3];
		break;
	    }
	    case "CSDVersion": //win 2000 e XP usano questo come upgrade
	    {
		$os_upgrade=$temp[3];
		break;
	    }
	    case "Plus! VersionNumber": //win9x usa questo come upgrade
	    {
		$os_upgrade=$temp[3];
		break;
	    }
	    case "ProductId":
	    {
		$os_prid=$temp[3];
		break;
	    }
	    default:
	    {
		break;
	    }
	}
	$campo1=fgets($file,$file_dim);//carico una nuova riga dal file
    }


    //recupero informazioni sul processore
    while(!feof($file))
    {
	$temp=explode("\t",$campo1);
	//controllo se sto ancora nessa sezione relativa al micro, altrimenti esco
	if($temp[1]!="HARDWARE/0")
	{
	    break;
	}
	//estraggo i dati che mi servono
	switch($temp[2])
	{
	    case "Identifier":
	    {
		$proc_id=$temp[3];
		break;
	    }
	    case "ProcessorNameString":
	    {
		$proc_name=$temp[3];
		break;
	    }
	    case "VendorIdentifier":
	    {
		$proc_vend=$temp[3];
		break;
	    }
	    case "~MHz":
	    {
		$proc_speed=$temp[3];
		break;
	    }
	    default:
	    {
		break;
	    }
	}
	$campo1=fgets($file,$file_dim);//carico una nuova riga dal file
    }
    
    //visualizzo i dati generali
    echo "<CENTER><FONT size=5 color=#cc0000>$nome_pc</FONT></CENTER>\n";
    echo "<CENTER><TABLE border=1 bordercolor=\"#000099\" width=70% height=0%>\n";
    echo "<TR><TD width=30% align=\"right\">Memoria installata:</TD>";
    if($ram_memory!="")
    {
	echo "<TD width=60% align=\"left\">$ram_memory MB</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Processore:</TD>";
    if($proc_name!="") //winzozz prima dell'XP non contempla questa variabile
    {
	echo "<TD width=60% align=\"left\">$proc_name</TD></TR>";
    }
    else if($proc_id!="") //questa �per winzozz ante-XP
    {
	echo "<TD width=60% align=\"left\">$proc_id</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Frequenza:</TD>";
    if($proc_speed!="")
    {
	echo "<TD width=60% align=\"left\">$proc_speed MHz</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Produttore:</TD>";
    if($proc_vend!="")
    {
	echo "<TD width=60% align=\"left\">$proc_vend</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Dischi presenti:</TD>";
    if($proc_speed>0)
    {
	echo "<TD width=60% align=\"left\">$n</TD></TR>";
	//elenco tutti i dischi trovati con la loro capacita'
	for($i=0;$i<count($disk_size);$i++)
	{
	    echo "\n<TR><TD width=40% align=\"right\">Capacita' disco $i:</TD>";
	    echo "<TD width=60% align=\"left\">$disk_size[$i]</TD></TR>";
	}
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Sistema installato:</TD>";
    if($op_sys!="")
    {
	echo "<TD width=60% align=\"left\">$op_sys</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Build:</TD>";
    if($os_version!="")
    {
	echo "<TD width=60% align=\"left\">$os_version</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Aggiornamenti:</TD>";
    if($os_upgrade!="")
    {
	echo "<TD width=60% align=\"left\">$os_upgrade</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n<TR><TD width=40% align=\"right\">Product ID:</TD>";
    if($os_prid!="")
    {
	echo "<TD width=60% align=\"left\">$os_prid</TD></TR>";
    }
    else
    {
	echo "<TD width=60% align=\"left\">Non disponibile</TD></TR>";
    }
    echo "\n</TABLE></CENTER>\n";
    echo "<BR>\n";
    echo "<BR>\n";

    //estraggo i dati software
    $swcount=0;
    $keycount=0;
    $currkeycount=0;
    $fine=false;
    echo "<TABLE border=1 bordercolor=\"#ffffff\" width=100% height=0%>";
    echo "<TR><TH colspan=3><CENTER><FONT size=4 color=#00cc00>SOFTWARE RILEVATO</FONT></CENTER></TH></TR>";
    while(!feof($file))
    {
	//recupero la radice della chiave. Mi servono solo quelle "SOFTWARE/blahblahblah"
	$temp=explode("\t",$campo1);
	$regkey=explode("/",$temp[1]);
	if($regkey[0]=="SOFTWARE" AND $temp[2]!="")
	{
	    //nuova chiave software. Cerco tutti i parametri disponibili
	    $curr_regkey=$regkey[1];
	    //i 5 valori elencati qui sono stupidate di Winzozz, e non mi interessa visualizzarli
	    if($curr_regkey!="Directories" AND $curr_regkey!="Features" AND $curr_regkey!="TextCache" AND $curr_regkey!="Branding" AND $curr_regkey!="AddressBook")
	    {
		$swcount++;
	        $currkeycount=0;
	        while(!feof($file))
	        {
	    	    //recupero i parametri che mi servono
	    	    $keycount++;
		    $currkeycount++;
		
		    //se e' cambiata la chiave principale, visualizzo i dati e riparto
		    if($regkey[1]!=$curr_regkey)
		    {
			//riassumo i dati in tabella
		        $pippo=strstr($curr_regkey,"{");
		        $pippo=strlen($pippo);
		        if($progname!="" OR $progver!="" OR $progcreat!="" OR $proginst!="" OR $proguninst!="" OR $pippo==0)
		        {
		    	    echo "\n<TR><TH colspan=3 bgcolor=#000077><CENTER><FONT size=4 color=#cccc00>$curr_regkey</FONT></CENTER></TH></TR>";
			    if($progname!="" OR $progver!="" OR $progcreat!="")
			    {
				if($progname=="") {$progname=".";}
			        if($progver=="") {$progver=".";}
			        if($progcreat=="") {$progcreat=".";}
			        echo "\n<TR><TD width=40% align=\"center\"><FONT color=#aa6666>Produttore</FONT></TD><TD width=40% align=\"center\"><FONT color=#aa6666>Programma</FONT></TD><TD width=20% align=\"center\"><FONT color=#aa6666>Versione</FONT></TD></TR>";
			        echo "\n<TR><TD width=40% align=\"center\">$progcreat</TD><TD width=40% align=\"center\">$progname</TD><TD width=20% align=\"center\">$progver </TD></TR>";
			    }
			    else if($progname=="" AND $proginst!="")
		    	    {
				echo "\n<TR><TH colspan=3 align=\"center\"><FONT color=#aa6666>Percorso installazione</FONT></TH></TR>";
			        echo "\n<TR><TH colspan=3 align=\"center\">$proginst</TH></TR>";
		    	    }
		    	    else if($progname=="" AND $proguninst!="")
		    	    {
		    		echo "\n<TR><TH colspan=3 align=\"center\"><FONT color=#aa6666>Comando disinstallazione</FONT></TH></TR>";
		        	echo "\n<TR><TH colspan=3 align=\"center\">$proguninst</TH></TR>";
		    	    }
		    	    else
		    	    {
		        	echo "\n<TR><TH colspan=3 align=\"center\">Nessuna informazione disponibile.</TH></TR>";
		        	echo "\n<TR><TH colspan=3 align=\"center\">.</TH></TR>";
		    	    }
			}
		        $progname="";
		        $progver="";
		        $progcreat="";
		        $proginst="";
		        $proguninst="";
		        $fine=true;
    		    }
		    switch ($temp[2])
		    {
			case "DisplayName":
		        {
			    $progname=$temp[3];
			    break;
			}
		        case "QuietDisplayName": //alcuni software usano questo al posto del "DisplayName"
			{
			    $progname=$temp[3];
			    break;
			}
			case "DisplayVersion":
		        {
		    	    $progver=$temp[3];
			    break;
			}
			case "Publisher":
			{
			    $progcreat=$temp[3];
			    break;
			}
			case "InstallLocation":
			{
			    $proginst=$temp[3];
			    break;
			}
			case "UninstallString":
			{
			    $proguninst=$temp[3];
			    break;
			}
			default:
			{
			    break;
			}
		    }
		    if($fine)
		    {
			$fine=false;
		        break;
		    }
		    else
		    {
			$campo1=fgets($file,$file_dim);//carico una nuova riga dal file
		        $temp=explode("\t",$campo1);
		        $regkey=explode("/",$temp[1]);
		    }
		}
	    }
	}
	$campo1=fgets($file,$file_dim);//carico una nuova riga dal file
    }
    fclose($file);
    //riassunto chiavi software trovate
    echo "\n<TR><TH colspan=3 align=\"center\"><FONT color=#cc0000>Sono state elaborate </FONT><FONT color=#0000cc>$swcount</FONT><FONT color=#cc0000> chiavi e </FONT><FONT color=#0000cc>$keycount</FONT><FONT color=#cc0000> parametri relativi a software installato.</FONT></TH></TR>";
    echo "\n</TABLE>";
}

/****************************************************
 *                    crea_form                     *
 ****************************************************
 Crea il semplice form di autenticazione con i
 campi "Utonto" e "Password".
 L'ho messo qui solo perche' lo uso piu' di una
 volta nelle varie pagine PHP.
*/
function crea_form()
{
    echo "<FORM action='' method='post'>\n";
    echo "Utonto<BR>\n";
    echo "<input type='text' name='username'><BR><BR>\n";
    echo "Password<BR>\n";
    echo "<input type='password' name='password'><BR><BR>\n";
    echo "<INPUT type='submit' name='accedi' value='Accedi'>\n";
    echo "</FORM>\n";
}

/****************************************************
 *                    crea_data                     *
 ****************************************************
 Visualizza semplicemente il timestamp di 
 generazione della pagina.
 L'ho messo qui solo perche' lo uso spesso nelle
 varie pagine PHP.
*/
function crea_data()
{
    $datacreaz= date("F j, Y, g:i a");
    echo "<CENTER><FONT size=\"2\">$datacreaz</FONT</CENTER>";
}
?>